Arch "Окно"

From FreeCAD Documentation
Jump to navigation Jump to search
This page is a translated version of the page Arch Window and the translation is 65% complete.
Outdated translations are marked like this.
Other languages:
Deutsch • ‎English • ‎español • ‎français • ‎italiano • ‎polski • ‎português do Brasil • ‎română • ‎svenska • ‎čeština • ‎русский • ‎українська

Arch Window.svg Окно

Системное название
Arch_Window
Расположение в меню
Архитектура → Окно
Верстаки
Arch
Быстрые клавиши
W I
Представлено в версии
-
См. также
Стена, Добавить компонент

Описание

Arch Window (окно) это базовый объект для всех типов "внедряемых" объектов, таких как окна, двери и т.д... Он спроектирован так, что может быть и независим, и "базироваться" на другом компоненте вроде стены, структуры, или крыши. У него своя собственная геометрия, которая может быть сделана из нескольких твердотельных компонентов (обычно оконная рама и внутренняя панель), и определяет объём, которые будет вычитаться из базового объекта, чтобы сделать проём.

Объекты Window базируются на замкнутых двумерных объектах, вроде прямоугольников или эскизов, которые используются для определения их внутренних компонентов. Базовые двумерные объекты должны, следовательно, содержать несколько замкнутых многоугольников, которые могут быть скомбинированы для создания заполненных панелей (один многоугольник) или рамок (несколько многоугольников).

Инструмент Window предлагает несколько предустановок, это позволяют пользователю создать общие типы окон и дверей с некоторыми редактируемыми параметрами, без необходимости создавать вручную двумерные объекты и компоненты.

Вся информация, применимая к Arch Window, также относится к Arch Door, поскольку это один и тот же базовый объект. Основное различие между окном и дверью состоит в том, что у двери есть внутренняя панель, которая показана непрозрачной (сама дверь), в то время как окно имеет частично прозрачную панель (стекло).

Arch Window example.jpg

Окно построено поверх прямоугольника Draft, а затем вставлено в стену Arch. Использование операции Arch Add автоматически прорезает требуемый проем в главной стене.

Arch Window example2.jpg

Более сложное окно, созданное на базе эскиза. При входе в режим редактирования окна, Вы можете создать различные компоненты, установить их толщину, и выделить и назначить многоугольники из эскиза для них.

Применение

Применение предустановок

  1. Нажмите кнопку Arch Window.svg Окно, или нажмите клавиши W, затем I
  2. Выберите предустановку из списка
  3. Заполните желаемые параметры
  4. В трёхмерном просмотре переместите окно в то место, где вы хотите его разместить. Если вы наведете указатель на Arch Wall, контур окна должен выровняться относительно лицевой стороны этого объекта.
  5. Щелкните мышью на трёхмерном просмотре или трижды нажмите клавишу Enter, чтобы подтвердить координаты X, Y, Z места размещения.

Note: if you install the "Parts Library" from the AddonManager, the window tool will search this library for additional presets. These presets are FreeCAD files containing a single window based on a parametric sketch that has named constrains. You may place additional presets in the parts_library directory so that they are found by the window tool.

$ROOT_DIR/Mod/parts_library/Architectural\ Parts/Doors/Custom/
$ROOT_DIR/Mod/parts_library/Architectural\ Parts/Windows/Custom/

The $ROOT_DIR is the user's directory where FreeCAD configuration, macros, and external workbenches are stored.

  • On Linux it is usually /home/username/.FreeCAD/
  • On Windows it is usually C:\Users\username\Application Data\FreeCAD\
  • On Mac OSX it is usually /Users/username/Library/Preferences/FreeCAD/

Создание с нуля

  1. По желанию, выделите грань объекта, где Вы хотите вставить окно
  2. Переключитесь на верстак Sketcher
  3. Создайте новый эскиз
  4. Нарисуйте одну или более замкнутых ломаных (петель)
  5. Закройте эскиз
  6. Переключитесь обратно на верстак Arch
  7. Нажмите кнопку Arch Window.svg Arch Window, или нажмите клавиши W, затем I
  8. Чтобы настроить компоненты окна и различные свойства, войдите в окно панели задач, дважды щелкнув созданный объект в древе проекта.

Note: when creating the sketch, pay close attention to the creation order of the loops; the numbering of the "wires" in the task panel ("Window elements") depends on this.

Предустановки

Доступны следующие предустановки:

Создание компонентов

Окна могут включать 3 типа компонентов: панели, рамы и жалюзи. Панели и жалюзи делаются из замкнутых ломаных, которые выдавливаются, в то время как рамы делаются из двух и более замкнутых ломаных, где каждый выдавливается, затем меньший вычитается из большего. Вы можете иметь доступ, создавать, модифицировать и удалять компоненты в окне в режиме редактирования (дважды кликнув по окну в древе проекта). У компонента имеются следующие параметры:

  • Name: имя компонента
  • Type: тип компонента. Может быть "Frame", "Glass panel", "Solid panel" или "Louvres"
  • Wires: разделяемый запятыми список ломаных, на которых базируется компонент
  • Thickness: толщина выдавливания компонента
  • Z Offset: расстояние между компонентом и его базовой ломанной
  • Hinge: позволяет выбрать край базового 2D-объекта, а затем установить этот край в качестве места для петель этого компонента и следующих в списке.
  • Opening mode: если вы определили край для петель в этом компоненте или любом другом ранее в списке, установка режима открытия позволит окну казаться открытым или отображать 2D-символы открытия в плане или на фасаде.

Arch Window options.jpg

Опции

  • Окно разделяет общие параметры и действие со всеми компонентами Arch
  • Если метка Auto-include на панели задач создания окна не отмечена, окно не будет вставлено в базовый объект при создании.
  • Добавить выделенное окно в стену, выделив оба и нажатием кнопки Arch Add.svg Arch Add.
  • Убрать выбранное окно из стены выделив окно, затем нажав кнопку Arch Remove.svg Arch Remove.
  • При использовании предустановок часто полезно включить привязку "Near", чтобы Вы смогли привязать окно к существующей грани.
  • Отверстие, создаваемое окном в базовом объекте, определяется двумя параметрами: ДанныеHole Depth и ДанныеHole Wire (introduced in version 0.17). Число Hole Wire может быть получено в трёхмерном окне из панели задач окна, доступной при двойном клике на окне в древе проектов
  • Окна могут использовать Multi-Materials. Окно ищет в присоединённом Multi-Material слои материала с теми же именами для каждого компонента окна, и используют их при нахождении. Например, компонент под названием "OuterFrame" ищет в приложеннном Multi-Material материальный слой под именем "OuterFrame". Если этот слой найден, его материал будет назначен компоненту OuterFrame. Значение толщины слоя материала отбрасывается.

Openings

See also: Tutorial for open windows

Двери и окна могут отображаться частично или полностью открытыми в 3D-модели или могут отображать открывающие символы как в плане, так и в области высоты. Следовательно, они также появятся в извлеченных 2D-представлениях, сгенерированных Draft Shape2DView или TechDraw Workbench или Drawing Workbench. Чтобы получить это, по крайней мере один из компонентов окна должен иметь шарнир и режим открытия (см. Создание компонентов выше). Затем вы можете настроить внешний вид окна, используя свойства ДанныеOpening, ДанныеSymbol Plan или ДанныеSymbol Plan:

Arch window openings.png

A door showing the symbol plan, symbol elevation and opening properties at work

Defining window types

Windows can also take advantage of other tools, specifically PartDesign workflows, to define a type. A type is an object that defines the shape of the window. This is specially well suited to work with App Parts:

Arch window type example.png

Download the example file shown above

Example workflow

  • Create a window frame object, a glass panel, and any other window component you need, using Part Workbench or PartDesign tools.
  • For example, create a base rectangular sketch for your window, then a profile sketch for the frame, and create a Part Sweep to sweep the profile around the base sketch. Create a Part Offset2D from the base sketch, then a Part Extrude to create the glass panel
  • Make sure all these pieces have a unique, meaningful name (for example, "Frame" or "Glass Panel")
  • Create an App Part, and place all your subcomponents in it
  • Create a volume to be subtracted from the wall, for example by extruding the base sketch. Add this volume to the App Part. Make sure the volume is turned off
  • If using FreeCAD version 0.19 or later, you can add 3 properties to your App Part, by right-clicking its properties view, and check "Show All". Add the following properties (all of them are optional, the group doesn't matter):
    • Height as a PropertyLength and link it, for example, to a vertical constraint of your base sketch
    • Width as a PropertyLength and link it, for example, to a horizontal constraint of your base sketch
    • Subvolume as a PropertyLink and link it to the volume to be subtracted that we created above
    • Tag as a PropertyString

Materials

Our window type is now ready. We can create window objects from it, simply by selecting the App Part and pressing the window button. The "Height", "Width", "Subvolume" and "Tag" properties of the window will be linked to the corresponding property of the App Part, if existing.

To build a material for type-based windows:

  • Create a multi-material
  • Create one entry in the multi-material for each component of your App Part. For example, one "Frame", one "Glass panel" as we used above. Make sure to use the exact same name.
  • Attribute that multi-material to each of the windows derived from the same type


You can use any other kind of workflow than the one described above, the important points to remember are:

  • The type object must be one object, no matter the type (App Part, PartDesign Body, Part Compound, or even another Arch Window)
  • The type object must have a "Subvolume" property (linked to the window's Subvolume property) for openings in host objects to work
  • The type object must have a "Group" property with different children with same names as multi-material items for multi-materials to work

Свойства

  • ДанныеHeight: Высота окна
  • ДанныеWidth: Ширина окна
  • ДанныеHole Depth: Глубина углубления, созданного окном в базовом объекте
  • ДанныеHole Wire: Номер многоугольника, используемого для создания проёма окна. Значение может быть установлено графически двойным кликом на окне в древе проекта. Если установить значение в ноль, для проёма будет автоматически браться наибольший многоугольник.
  • ДанныеWindow Parts: Список струн (5 струн на компонент, установка опций компонента выше)
  • ДанныеLouvre Width: Если какой-либо из компонентов установлен в "Louvres (жалюзи)", этот параметр определяет размер элементов жалюзи
  • ДанныеLouvre Spacing: Если какой-либо из компонентов установлен в "Louvres (жалюзи)", этот параметр определяет пробел между элементами жалюзи
  • ДанныеOpening: все компоненты, для которых установлен режим открытия, и при условии, что в них или в более раннем компоненте в списке определен шарнир, будут отображаться открытыми в процентах, определяемых этим значением.
  • ДанныеSymbol Plan: отображение двумерного символа проема на виде сверху
  • ДанныеSymbol Elevation: показывает двумерный символ проема на фасаде

Сценарии

См. так же: Arch API и Основы написания скриптов FreeCAD.

Инструмент создания окон может использоваться в макросах и их консоли Python, с использованием следующих функций:

Window = makeWindow(baseobj=None, width=None, height=None, parts=None, name="Window")
  • Создает объект Window на основе baseobj, который должен быть правильно сформированной замкнутой ломанной или эскизом Sketcher.
  • Если доступно, устанавливает width, height и name (метку) окна.
  • Если baseobj не является замкнутой формой, инструмент может не создать правильную сплошную фигуру.

Пример:

import FreeCAD, Draft, Arch

Rect1 = Draft.makeRectangle(length=900, height=3000)
Window = Arch.makeWindow(Rect1)
FreeCAD.ActiveDocument.recompute()

Вы можете так же создать окно из предустановок.

Window = makeWindowPreset(windowtype, width, height, h1, h2, h3, w1, w2, o1, o2, placement=None)
  • Создает объект Window на основе windowtype, который должен быть одним из имен, определенных в Arch.WindowPresets
    • Некоторые из этих предустановок: "Fixed", "Open 1-pane", "Open 2-pane", "Sash 2-pane", "Sliding 2-pane", "Simple door", "Glass door", "Sliding 4-pane".
  • width и height определяют общий размер объекта в миллиметрах.
  • Параметры h1, h2, h3 (вертикальные смещения), w1, w2 (ширина), o1 и o2 (горизонтальные смещения) определяют разные расстояния в миллиметрах и зависят от типа создаваемой предустановки.
  • Если задано placement, используется оно.

Пример:

import FreeCAD, Arch

base = FreeCAD.Vector(2000, 0, 0)
Axis = FreeCAD.Vector(1, 0, 0)
place=FreeCAD.Placement(base, FreeCAD.Rotation(Axis, 90))

Door = Arch.makeWindowPreset("Simple door",
                             width=900, height=2000,
                             h1=100, h2=100, h3=100, w1=200, w2=100, o1=0, o2=100,
                             placement=place)